#include <cstdio>
#include <cstdlib>
#include <vector>
using namespace std;

extern long long place_police(vector<int> P, vector<long long> C, vector<long long> W);

void my_assert(bool x) {
	if (!x) {
		puts("Wrong input");
		exit(0);
	}
}

int main() {
	int N;
	my_assert(scanf("%d", &N) == 1);
	vector<int> P(N - 1);
	vector<long long> C(N - 1), W;
	vector<int> cnt(N);
	for (int i = 0; i < N - 1; i++) {
		my_assert(scanf("%d %lld", &P[i], &C[i]) == 2);
		cnt[i+1]++;
		cnt[P[i]]++;
	}
	for (int i = 0; i < N; i++) {
		if (cnt[i] == 1) {
			long long w;
			my_assert(scanf("%lld", &w) == 1);
			W.push_back(w);
		}
	}

	printf("%lld\n", place_police(P, C, W));

	return 0;
}
